import java.lang.ref.WeakReference;

public class GC {
    String name;
    public GC(String name) {
        System.out.println("new "+name);
        this.name = name;
    }

    protected void finalize() throws Throwable {
        System.out.println("finalize "+name);
    }

    public static void main(String[] args) throws InterruptedException {
        int count = Integer.parseInt(args[0]);
        for (int i=0; i<count; i++) {
            new GC(""+i);
        }
        System.out.println("GC run 1");
        System.gc();
        Thread.sleep(1000);
        System.out.println("GC run 2");
        System.gc();
        Thread.sleep(1000);
        System.out.println("GC run 3");
        System.gc();
        Thread.sleep(1000);
        System.out.println("End.");
    }
}
